
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>Redis内核基于时间点的备份恢复和基于AOF日志的增量同步机制设计 / iVAN</title>

    <meta name="description" content="Redis内核基于时间点的备份恢复和基于AOF日志的增量同步机制设计 直播视频回顾 Redis内核支持基于时间点的备份恢复 Redis内存数据库,须有一种机制能够把内存中的数据持久化到硬盘上,再将硬盘中数据备份到备份系统中,才能去做恢复.Redis原生的持久化机制包括RDB持久化和AOF持久化两种. RDB持久化 RDB持久化触发方式有两种: 手动触发:执行BGSAVE命令: 自动触发:配置SAVE选项,在指定时间内发生指定次数的key修改,自动进行后台RDB SAVE. RDB持久化流程如下: 在做RDB SAVE时需要fork一个子进程,每次RDB SAVE生">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">Redis内核基于时间点的备份恢复和基于AOF日志的增量同步机制设计</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<p>直播视频回顾</p>
<p>Redis内核支持基于时间点的备份恢复</p>
<p>Redis内存数据库，须有一种机制能够把内存中的数据持久化到硬盘上，再将硬盘中数据备份到备份系统中，才能去做恢复。Redis原生的持久化机制包括RDB持久化和AOF持久化两种。</p>
<p><b>RDB</b><b>持久化</b></p>
<p>RDB持久化触发方式有两种：</p>
<ul>
<li>手动触发：执行BGSAVE命令；</li>
</ul>
<ul>
<li>自动触发：配置SAVE选项，在指定时间内发生指定次数的key修改，自动进行后台RDB SAVE。</li>
</ul>
<p>RDB持久化流程如下：</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tL2NiNWJjZDFmOWJmZjExMGZiNjgxMWU1ZGUwNWNmMDg2ZDI0NGJiZWQucG5n.jpg"></p>
<p>在做RDB SAVE时需要fork一个子进程，每次RDB SAVE生成一个对应时间点的内存快照文件。</p>
<p><b>AOF</b><b>持久化</b></p>
<p><b><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tLzcyZjY0MGIxODQxNDNkZmFjZTdjN2ViOGI0ODY5ZmVmOGU5ZmY5MGUucG5n.jpg"><br /></b></p>
<ul>
<li>
配置appendonly选项，可以动态开关；
</li>
</ul>
<ul>
<li>
和RDB持久化不太一样的是，每一次的写操作命令都会追加到aof文件中，根据配置的appendfsync选项不同，会有不同aof文件刷新策略；
</li>
</ul>
<ul>
<li>
Redis通过AOF Rewrite的方式来“紧凑”AOF，解决持续追加导致AOF文件过大的问题。
</li>
</ul>
<p><b>当前备份恢复方式</b></p>
<p>现在Redis内核能够支持的备份方式有两种：</p>
<p>1.        备份RDB：执行BGSAVE命令 -&gt; Fork子进程 -&gt; 生成rdb文件 -&gt; 备份rdb文件；</p>
<p>2.        备份AOF：根据aof大小判断是否需要先做一次AOF Rewrite，备份aof，AOF Rewrite同样需要Fork子进程。</p>
<p>两种方式都是备份一个全量数据文件，通常不会选择备份aof，rdb格式更为紧凑，备份开销更小。</p>
<p>恢复时，创建实例，从备份系统拉取全量的aof或rdb文件到实例数据目录，恢复数据。</p>
<p>当前内核备份恢复方式只能做全量数据的备份和恢复，fork子进程生成全量快照的方式开销比较大。</p>
<p><b>应用场景举例</b></p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tLzVhZTE1Y2I1NGRmMjI1Njg1MjEyMWJjMjZkOTdkZGU1NTRiNzliMTQucG5n.jpg"></p>
<p>如果能够不管几点上线，都能恢复Redis数据到那个时间点，场景中的问题将不再存在。</p>
<p><b>Redis</b><b>基于时间点的备份恢复</b></p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tLzMwM2FmMWY5YWQ0NzAxZWM5YzBiNTY3MTQ4MDM2YWIwZmM5MGJmMDEucG5n.jpg"></p>
<p>我们的目标就是要恢复数据到任意时间点，我们做了基于AOF改造的增量日志，禁用AOF Rewrite，日志按照配置大小自动切分。除了每个命令执行的历史日志要保存下来，还需要添加一些额外的信息，比如：</p>
<ul>
<li>根据系统时间戳命名AOF，AOF中除了包含原有的Redis协议格式的命令(Oplog)，每个Oplog还对应了一个Header；</li>
<li>Header中包含多个字段，其中timestamp记录了命令执行时的时间戳，基于任意时间点恢复时就依赖于该信息；</li>
<li>server_id、opid和dbid是为后面讲的主从同步优化所设计，reserved为保留字段；</li>
<li>Oplog Header以二进制的形式用Redis命令封装，保持AOF协议格式不变。</li>
</ul>
<p><b>AOF</b><b>日志管理</b></p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tLzRkOTdkMjliOGExOWI5ZWI4MWQ3NWFhNzI1ZTMxMzViYjI0M2M3MzIucG5n.jpg"></p>
<p>AOF会按固定大小做切分，我们需要将AOF日志进行管理，主要有以下三点：</p>
<p>1.        使用AOF Index索引文件记录Redis当前维护的AOF文件；</p>
<p>2.        使用专门的清理命令删除AOF，同时维护AOF index文件的正确性；</p>
<p>3.        BGSAVE完成时需要记录RDB文件对应的AOF日志名和文件写入偏移，这个信息保存在rdb index文件中。</p>
<p><b>本地定时</b><b>BGSAVE</b></p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tLzg5ZDAzODA4M2QyMWIwMDU0OTNmOGM5Mjg3ZmMyMWI2NjY1OGMyNjIucG5n.jpg"></p>
<p>我们也需要本地定时BGSAVE机制，AOF会越变越大，仍然需要某种方式来“紧凑”AOF日志，比如AOF Rewrite方式复合式进程重写AOF日志，Redis实例在本地也需要保存一份持久化的全量数据，重启时从AOF日志恢复数据是不现实的。</p>
<p>对此，我们引入Cron BGSAVE，当AOF日志的增长量满足一定条件时，触发BGSAVE，生成RDB文件，该RDB文件对应的时间点之前的AOF日志在本地都是不需要的，只要已经上传到备份系统，即可删除。</p>
<p><b>备份恢复流程</b></p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tLzRjNjQ1MjEyZWEyM2ZiMGJjYzhlZGFlYmE5MjkyZDZjMDY0NGNlOTEucG5n.jpg"></p>
<p>时间点备份恢复的流程如图所示，左侧假如有一个Redis-Server实例，追加写AOF6文件，接着实时备份AOF日志，上传到备份空间中，同时也有定时全量备份，每一个RDB文件会对应一个RDB文件写入偏移，每个AOF文件会有一个起始时间；右侧指定要恢复的时间点，Redis顺序加载RDB、AOF到指定地点。</p>
<p>备份和原来全量备份的区别在于，需要实时持续地把Redis生成的AOF增量日志不断的备份下来，我们也要有删除的机制，比如保存一个星期或一个月的情况。</p>
<p>Redis基于AOF日志的增量同步机制设计</p>
<p>Redis原生同步机制主要有两种，全量同步和增量同步。</p>
<p><b>全量同步</b></p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tL2RkMzZjNWJkNzYyODgzM2U5NDI1YmRmZDVlNGQ5MmVlZWM1YmNjY2EucG5n.jpg"></p>
<p>全量同步代价非常大，全量同步意味着有一个空的Redis实例挂上来后，Master需要做一次BGSAVE，还需要网络传输RDB文件，发送给slave，大量占用主库带宽、cpu资源，大内存时fork会导致redis hang住，虽然fork是写实复制，但需要copy页表，如果内存比较大，页表也会比较大。</p>
<p><b>增量同步</b></p>
<p>Redis在2.8中引入了增量同步机制，是为了解决网络偶尔的抖动导致需要全量同步的问题。</p>
<p>增量同步机制实现比较简单，master和slave之间维护一个一致的同步offset，此外，master还在内存里面维护了一个同步buffer，保存了最近一段时间内的更新命令日志，当slave断链重连时，会根据自己的同步偏移从master的同步buffer直接拉取数据，完成同步。</p>
<p>理想情况下，这个流程同步很快，代价很低，但是当网络断开时间较长时，或主库写入非常大时，同步Buffer会将历史数据覆盖掉，仍然需要全量同步。而且，现有的增量同步机制，也没有解决一主多从场景下，主从切换，其他从需要从新主全量同步的问题。</p>
<p><b>应用场景举例</b></p>
<p>有不少使用Redis的业务的重要性很高，譬如说金融业务，都有跨机房，甚至跨地域灾备的需求，而跨机房或跨地域的网络质量往往很难保证。</p>
<p>假设有一天，Redis业务的杭州主机房和深圳的备机房之间的光纤被人挖断了，网络中断数小时，恢复后，深圳机房所有的备实例同时发起全量同步，导致的后果很可能是：主库所在机器带宽、cpu打满，甚至有些机器会直接OOM，而备又还没有完成同步，后果可能是灾难性的，对此，我们该如何处理呢？</p>
<p><b>基于</b><b>AOF</b><b>日志的增量同步（</b><b>AOF PSYNC</b><b>）</b></p>
<p>由于现有机制存在的问题，以及真实场景中业务需求的推动，我们想到不依赖于具体内存的Buffer，用增量日志做增量同步，那么，基于AOF日志的增量同步是怎么实现的呢？具体原理解释如下：</p>
<ul>
<li>当主从同步断开，需要拉取增量时，会先选择尝试基于同步偏移从主库同步buffer获取数据，如果同步buffer缺少增量数据，会开始从AOF日志获取增量；</li>
<li>AOF PSYNC以AOF日志中的opid作为同步基准，slave继承从主库同步过来的opid，并记录在自己的AOF日志中；</li>
<li>使用opid作为同步基准是因为对于带过期时间的命令，Redis写AOF和写同步buffer的字节序列不一样，Redis在写AOF时会转换设置过期时间的命令为PEXPIREAT；</li>
<li>AOF日志中的dbid，决定了AOF中的每条命令写入的db是哪个。AOF PSYNC同步完成后，会同步master和slave间的同步偏移。</li>
</ul>
<p><b>AOF PSYNC</b><b>流程</b></p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tLzkwMzFkODJkYjUyMzFkZGFhOWYyZDM4MTc4MTAxMzJhNmFlZDcwMDYucG5n.jpg"></p>
<p>1.        Master收到Slave的AOF PSYNC请求后，会使用后台线程来查找offset，避免server hang住；</p>
<p>2.        根据slave发送的opid查找到起始的AOF文件后会异步的通知主线程；</p>
<p>3.        主线程会异步发送一个或多个AOF文件给SLAVE，发送完成后，需要同步aof buffer；</p>
<p>4.        如果slave给定的opid在master的AOF中不存在（AOF可能被异常删除），会发起全量同步。</p>
<p>阿里云Redis服务</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tLzdmNmFhMTE1MDJkOTU3OTJkNDIwYjY4YmViMDNjZmQxNzRlZTQ5OTYucG5n.jpg"></p>
<p>与其它Redis对比，阿里云Redis服务具备高可靠、高性能、高扩展、易用的特点。</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-03-01 00:30:41</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.iamivan.net/tag/%e4%ba%91%e6%a0%96%e7%a4%be%e5%8c%ba/" title="云栖社区">云栖社区</a>, <a href="https://www.iamivan.net/tag/%e9%98%bf%e9%87%8c%e4%ba%91/" title="阿里云">阿里云</a>, <a href="https://www.iamivan.net/tag/%e5%90%8c%e6%ad%a5/" title="同步">同步</a>, <a href="https://www.iamivan.net/tag/%e9%85%8d%e7%bd%ae/" title="配置">配置</a>, <a href="https://www.iamivan.net/tag/%e7%ba%bf%e7%a8%8b/" title="线程">线程</a>, <a href="https://www.iamivan.net/tag/%e6%97%a5%e5%bf%97/" title="日志">日志</a>, <a href="https://www.iamivan.net/tag/redis/" title="redis">redis</a>        </div> -->
	</section>
	
	

		<div id="similar">

		<h3>Redis内核基于时间点的备份恢复和基于AOF日志的增量同步机制设计的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bjak7Wz.html" rel="bookmark">【TSPITR】RMAN表空间基于时间点的自动恢复</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				[RMAN]TSPITR--RMAN表空间基于时间点的自动恢复 1.1  BLOG文档结构图       1.2  前言部分   1.2.1  导读 各位技术爱好者,看完本文后,你可以掌握如下的技能,也可以学到一些其它你所不知道的知识,~O(∩_∩)O~: ① TSPITR表空间基于时间点的自动恢复 ② logminer的简单应用   本文如有错误或不完善的地方请大家多多指正,ITPUB留言或QQ皆可,您的批评指正是我写作的最大动力. 1.2.2  实验环境介绍   目标库:11.2.0.3 			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pPXr7Dp.html" rel="bookmark">不完全恢复之--基于时间恢复</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				探索ORACLE不完全恢复之--基于时间恢复 作者:吴伟龙   Name:Prodence Woo QQ:286507175  msn:hapy-wuweilong@hotmail.com 基于时间(time)恢复 基于时间的恢复将数据库恢复到备份点与失败点之间的某个时间点.基于时间的恢复不仅在介质失败的时候使用,也可以在数据库正常运行的时候使用.例如:某个用户误删除了某个表的数据,这个时候我们可以通过基于时间的恢复来将删除的数据恢复出来,示例如下:   1.查看当前用户下的表,只有一张WWL0			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pdW4m6M.html" rel="bookmark">基于时间点的不完全恢复的例子</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				说到不完全恢复,一般有三种场景,基于时间点的不完全恢复,基于scn的不完全恢复,基于cancel的不完全恢复. 三种情况都是不完全恢复采用的方式,而不完全恢复都是在完全恢复的过程中出现了这样那样的错误,数不胜数,基本就是归档,redo损坏丢失,控制文件丢失,备份的问题,手工失误等等. 我们可以举一个不完全恢复的案例,其实在实际操作的过程中还是有一些值得总结和学习的地方. 第一步准备基本的数据.目前我们可以看到在表空间data上只有一个表new_recover SQL&gt; select owner,			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zDWm00p.html" rel="bookmark">基于Linux下 Oracle 备份策略&lpar;RMAN&rpar;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				基于Linux下 Oracle 备份策略(RMAN) --********************************** -- 基于Linux下 Oracle 备份策略(RMAN) --**********************************       对于 Oracle 数据库的备份与恢复,尽管存在热备,冷备以及逻辑备份之外,使用最多的莫过于使用RMAN进行备份与恢复.而制定RMAN备份策略则是基于数据库丢失的容忍程度,即恢复策略来制定.在下面的备份策略中,给出的是一个通用			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/b2Y7vkz.html" rel="bookmark">MongoDB秒级备份恢复&lpar;SDCC上海站数据库核心技术与应用实战峰会分享PPT&rpar;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				本文是我3月18日在CSDN举办的SDCC上分享的PPT内容,主要介绍如何对MongoDB复制集及分片集群实现任意时间点的备份恢复,猛击这里下载PDF版本			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/M6eWQLb.html" rel="bookmark">云数据库Redis版备份恢复解决方案上线，数据可靠性全面升级！</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				阿里云云数据库Redis版致力于为用户提供稳定可靠.性能卓越.可弹性伸缩的数据库服务,并提供全套的容灾切换.故障迁移.在线扩容.性能优化的数据库解决方案. 云数据库Redis版采用双击热备的架构保证服务高可用,并且提供了持久化机制来保证数据可靠性.但是随着越来越多的业务开始使用Redis作为最终的持久化存储引擎,用户对于数据可靠性就提出了更高的需求.经过一段时间的打磨,我们正式推出了Redis备份恢复解决方案,全面的升级云数据库Redis的数据可靠性.   1.     数据备份一键式操作 由于			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bK7kvnb.html" rel="bookmark">Oracle技术：基于时间点的表空间恢复</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				TSPITR(表空间时间点恢复)用于将一个或多个表空间恢复到过去某个时间点的状态,而其他表空间仍然保持现有状态. TSPITR 相关的概念和术语: (1) TSPITR (Tablespace Point-In-Time Recover).TSPITR 是表空间时间点恢复的英文缩写格式,它表示将一个或多个表空间恢复到过去时间点的状态,而其他 表空间仍然保持现有状态. (2) TSPITR 实现方法.当实现表空间时间点恢复时,既可以使用用户管理的表空间时间点恢复方法,也可以使用RMAN 管理的表空			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/M9Xw8Rb.html" rel="bookmark">RAC 数据库恢复到单实例下并且基于时间点恢复</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				RAC 下基于时间点的恢复1.源库进行备份 我这里进行了2次备份2.拷贝2次的备份集到目标机器上,在目标机器上建立好SPFILE.3.使用recover controlfile from 进行控制文件恢复,这个没什么好说的确定好控制文件所在备份集进行恢复就可以了.4.重新命名进行恢复 run {set newname for datafile '+DATA/rac/datafile/system.270.790795355' to '/home/oradba/db/rac/system.dbf'			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pd7653M.html" rel="bookmark">Oracle技术：手动实现表空间基于时间点的恢复</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				实验说明: (1)先创建2个表空间. create tablespace user01 datafile '/opt/oracle/oradata/ocp/user01.dbf' size 1M; create tablespace user02 datafile '/opt/oracle/oradata/ocp/user02.dbf' size 1M; (2)在每个表空间上各创建一张表. create table scott.customers (cust_id int,cust_name v			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/xp8Zkxb.html" rel="bookmark" class="title">常见正则表达式汇总【一】</a>
					<div>
						1.  匹配行的起始和结束: Ip as-path access-list 20 permit 850 该过滤器匹配任何包含字符串 850 的 as-path .匹配的 as-path 例如:( 85 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/4MYB6xp.html" rel="bookmark" class="title">ASP采集页面内容组件Microsoft&period;XMLHTTP</a>
					<div>
						xml|采集|页面 &lt;%'================================================='过程名:getHTTPPage'作  用:获取页面内容'参  数:u ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/xp8laVp.html" rel="bookmark" class="title">Resin服务器的使用</a>
					<div>
						服务器 一.Java Web服务器选择简介在实际进行java Web项目实施的时候,我们可以采用的商业java Web服务器有Ibm WebSphere,Bea Web Logic.这两种服务器 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/XMlDGLM.html" rel="bookmark" class="title">触发器概述</a>
					<div>
						   在上面几节我们介绍了一般意义的存储过程,即用户自定义的存储过程和系统存储过程.本节将介绍一种特殊的存储过程,即触发器.在余下各节中我们将对触发器的概念.作用以及对其的使用方法作详尽介绍,使读者了 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pXB96Ab.html" rel="bookmark" class="title">symbian资源文件中定义菜单</a>
					<div>
						在资源文件中定义菜单十分简单有如下几步: 第一步,在 EIK_APP_INFO 中定义一个菜单条,如下: RESOURCE EIK_APP_INFO { menubar = r_main_menuba ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MAay5AM.html" rel="bookmark" class="title">Apache 2&period;x服务器中的URL重写的配置和应用</a>
					<div>
						1.关于Apache 2.x URL别名的说明和设置: Apache 2.x 服务器中的URL别名规则的文档,它是通过rewrite模块来实现的.能过URL别名规则,我们能看到一个干净的URL,比如可 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p5Adwnp.html" rel="bookmark" class="title">J2ME游戏开发笔记整编版</a>
					<div>
						-------------一般类问题-------------- 1 J2ME中查表法使用三角函数 CLDC和MIDP都没有提供三角函数,而且CLDC1.0中也没有浮点数,所以我们的选择是查表.使用8 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MyrLA4p.html" rel="bookmark" class="title">电脑弹出rundll32&period;exe应用程序错误怎么办</a>
					<div>
						  解决方法: 遇到这种问题,首先使用安全软件对电脑磁盘进行全盘查杀,例如360安全卫士.腾讯安全卫士等等,彻底清除病毒木马以后再使用这些安全软件对rundll32.exe文件进行修复. 当然我们也可 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pnYLD2M.html" rel="bookmark" class="title">word2003中带圈字符的使用</a>
					<div>
						  在编辑word文档时,常常需要输入带圈的数字序列,比如①②③等,这样的带圈的数字序列小于或等于10的时候,可以利用键盘输入,但如果大于10的话,键盘则无法输入,这时则需要利用word2003中提供 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pP84NZp.html" rel="bookmark" class="title">360安全卫士怎么测试网速</a>
					<div>
						  1.首先哦们打开360安全卫士,然后我们点击&quot;宽带测试器&quot; 2.我们可以看到它正在测试 小编的网速是8M~10M之间,大家的网速是多少呢?					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zwxWBOb.html" rel="bookmark" class="title">背景图片-我的这段javascript代码有什么问题嘛？前端的</a>
					<div>
						问题描述 我的这段javascript代码有什么问题嘛?前端的 window.onload = function(){ var width = document.getElementById(&quo ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MYjBw9p.html" rel="bookmark" class="title">c&plus;&plus;-C&plus;&plus;warning C4552&colon; &OpenCurlyDoubleQuote;&ast;&rdquo;&colon; 运算符不起任何作用；应输入带副作用的运算符</a>
					<div>
						问题描述 C++warning C4552: &quot;*&quot;: 运算符不起任何作用:应输入带副作用的运算符 #include #include #include using namespa ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bamYKPb.html" rel="bookmark" class="title">ubuntu15&period;10 64位编译Android 5&period;0源码</a>
					<div>
						问题描述 ubuntu15.10 64位编译Android 5.0源码 使用的是ubuntu15.10 64 bit的,下载了Android 5.0的源码在, 准备编译,编译过程报如下错误: Inst ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/ze6v48b.html" rel="bookmark" class="title">c&plus;&plus;新手-c&plus;&plus;基础的问题，求解&excl;</a>
					<div>
						问题描述 c++基础的问题,求解! void str_cat(char*p1,char*p2) { *p1+=*p2; }这样编拼接函数,对吗?怎么输出用这个拼接函数得到的字符串和其长度,谢谢! 解决 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MW2n8nb.html" rel="bookmark" class="title">数据读写-qt 怎么将txt文本文档的数据导入到pdf里</a>
					<div>
						问题描述 qt 怎么将txt文本文档的数据导入到pdf里 为什么我导入的txt数据在pdf里只有一行呢!!!! 生成的pdf 原来的txt文档内容 解决方案 明显是回车换行的处理有问题,你是怎么样处理 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M1rA5Kp.html" rel="bookmark" class="title">O2O的电子化的发红包方式由来</a>
					<div>
						从年初的发红包事件可以看出,包红包也是件费劲的事,于是就想说是否可以用电子产品发明红包,于是就有了一个O2O的电子化的发红包方式,用&quot;腾讯微信+腾讯风铃&quot;的组合拳,进行电子转盘抽奖 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bjLxn8p.html" rel="bookmark" class="title">JAVA  enum实现简单状态机功能</a>
					<div>
						(转载请注明出处:http://blog.csdn.net/buptgshengod) 1.背景             我们做android应用,往往要进行多个状态的切换,就像是照相机功能的侦测,预 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p8ADdZz.html" rel="bookmark" class="title">小心家装前被忽悠：智能家居背后的安全隐患</a>
					<div>
						近日,未来学博士Ian Pearson发表了一篇关于10年后浴室智能化场景猜想的文章,结合人类现有的技术背景,Ian Pearson构想出一系列未来人类将在浴室内可体验到的智能化便利. 如通过智能镜子 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bQB8EOM.html" rel="bookmark" class="title">String类型值为null时部分&lpar;同样的定义，有些字段为null插入不报错&rpar;插入表字段为varchar的报&colon;无法识别JDBC类型 &colon; 0。求大神指导。。。</a>
					<div>
						问题描述 报错信息(用的DB2):代码片段:很奇怪的一件事,不知道是不是数据库版本原因.这个插入有好多个字段,很多java中定义String类型,数据库中定义varchar的,有些字段为nul时可以插 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pdy6JXz.html" rel="bookmark" class="title">达令礼物副总裁王西：走跟淘宝相反的路</a>
					<div>
						越来越多的创业者开始瞄准个性化礼物市场,达令礼物就是移动端布局的一款&quot;礼物App&quot;.达令礼物副总裁王西称,&quot;我们就是要走跟淘宝相反的路&quot;. 避开&quot;淘宝 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mrqdqxb.html" rel="bookmark" class="title">从社区常识说起 社区培育的问题与常见解法</a>
					<div>
						中介交易 SEO诊断 淘宝客 云主机 技术大厅 这篇文章全无深刻,只讲社区培育的一些常识.虽说是大路货,操作的时候也可能遗漏一些东西,我最近就在自检时发现了漏洞.惭愧. 先说说什么是&quot;社区& ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M60VeLz.html" rel="bookmark" class="title">阿里云将帮12306查票&comma;各航企陆续公布春运&OpenCurlyDoubleQuote;加班表&rdquo;</a>
					<div>
						1月27日消息,随着春节的临近,各个运输机构都在为备战春运而奋斗.对于外界有关阿里云与12306铁道部火车票订票网站合作的传闻,阿里云计算19日向南都记者予以确认,证实公司确实向12306提供了技术协 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MAERkeM.html" rel="bookmark" class="title">China Unicom and Chunghwa Telecom work together&amp;amp&semi;nb</a>
					<div>
						China Unicom and Chunghwa Telecom are planning to work together on iPhone platform. Incidentally, bo ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b2Z3Wob.html" rel="bookmark" class="title">分享Javascript中最常用的55个经典小技巧&lowbar;javascript技巧</a>
					<div>
						1. oncontextmenu=&quot;window.event.returnValue=false&quot; 将彻底屏蔽鼠标右键&lt;table border oncontextmenu= ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M1NLYap.html" rel="bookmark" class="title">手机端网页点击链接触发自动拨打或保存电话的示例代码&lowbar;javascript技巧</a>
					<div>
						通过网页拨打电话 &lt;a href=&quot;tel://110 &quot;&gt;拨打电话&lt;/a&gt; 这种方式塞班.安卓与iphone都支持 切记一定这这么写,不要自己写方法再去调 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pdmQjNz.html" rel="bookmark" class="title">Window Workflow自定义持久化</a>
					<div>
						问题描述 各位达人小弟在研究WF,但是不知道怎么实现WF的自定义持久化到Oracle数据库,不知道哪位好心人能提供实现方式供我参考参考,以前的帐户密码忘记了,新注册了这个用户,全部的分数奉上.谢谢!  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pk7vkyp.html" rel="bookmark" class="title">gaoliuchang 在不在啊 请进来帮忙 谢谢</a>
					<div>
						问题描述 http://topic.csdn.net/u/20080328/15/a7206a72-a26b-4b61-95c1-ac8656fcd157.html你这个帖子上的ajax控件是什么发给 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b3YDRNp.html" rel="bookmark" class="title">写在2009年的最后一天</a>
					<div>
						中介交易 http://www.aliyun.com/zixun/aggregation/6858.html&quot;&gt;SEO诊断 淘宝客 云主机 技术大厅 今天回到单位,已经是2010年的1 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MyK8XPz.html" rel="bookmark" class="title">100的阶层真的算不出来吗？</a>
					<div>
						今天看到一个蛮有意思的题,是问&quot;100!&quot;的尾数有多少个零. 尾数有多少个零,实际上指的是从这个数的最后一个不为0的数的下一个(也就是0)开始计数,一直到最后一个数(这些数自然都是 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pLBlmWb.html" rel="bookmark" class="title">2015年该如何重新分配市场研究预算</a>
					<div>
						企业市场研究总监在思考,对于下一个年度我们该如何分配市场研究预算?我会建议市场研究总监去和品牌总监甚至CMO重新商讨一下.大可不必依靠过去花费大小而预估未来,因为商业传播模式变了,我们必须正视意见领袖 ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 11 q. 0.031 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
